<!DOCTYPE html>
<html>
<head>
<link rel="icon" href="favicon.png" type="image/png">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source Sans Pro:400,700">
    <title>temperature, air pressure and humidity graphs</title>
    <style>
        @font-face {
            font-family: Source Sans Pro;

        }

        body {
            font-family: Source Sans Pro, monospace;
            color: #efd6d1;
            background-color: rgba(44, 62, 80, 0.9);
            display: flex;
            flex-wrap: wrap;
            justify-content: flex-start;
            border-radius: 4px; /* Abrundung der Ecken */
        }

        .chart-container, .wide-chart-container {
            background-color: rgba(4, 8, 16, 0.2);
            max-width: 100%;
            height: auto;
            color: #ecf0f1;
            border-radius: 4px; /* Abrundung der Ecken */
            margin: 5px;
            padding: 10px;
            box-sizing: border-box;
            float: left;
            width: calc(33.33% - 10px); /* 33.33% for three boxes */
        }

        .chart-container img {
            background-color: rgba(4, 8, 16, 0.2);
            max-width: 100%;
            height: auto;
            border-radius: 4px; /* Abrundung der Ecken */
        }

        .text {
            background-color: rgba(4, 8, 16, 0.2);
            max-width: 100%;
            height: auto;
            border-radius: 4px; /* Abrundung der Ecken */
        }

        .wide-chart-container {
            width: 100%;
            clear: both;
            font-color: color: #efd6d1;
            background-color: rgba(4, 8, 16, 0.2);
            margin: 10px;
            padding: 10px;
            border-radius: 4px; /* Abrundung der Ecken */
            box-sizing: border-box;

        }

        .wide-chart-container img {
            background-color: rgba(4, 8, 16, 0.2);
            max-width: 100%;
            border-radius: 4px; /* Abrundung der Ecken */
            height: auto;
        }

        @media (max-width: 800px) {
            .chart-container, .wide-chart-container {
                width: calc(100% - 10px);
                clear: both;
            }
        }
    </style>
</head>
<body>

<div>
    <div class="text">
        <h2>Air sensor data</h2>
        <p>Real-time measurements presented here; red represents current data, while blue indicates data from the previous day.</p>
    </div>

    <?php
    // Verbindung zur Datenbank herstellen
    $servername = "192.168.x.y";
    $username = "dbuser";
    $password = "password";
    $dbname = "sensor_data";
    $conn = new mysqli($servername, $username, $password, $dbname);

    // Überprüfen, ob die Verbindung erfolgreich hergestellt wurde
    if ($conn->connect_error) {
        die("Verbindung zur Datenbank fehlgeschlagen: " . $conn->connect_error);
    }

    // SQL-Abfrage, um den letzten Datensatz abzurufen
    $sql = "SELECT Innentemperatur, Aussentemperatur, AirQuality, Gaswiderstand, AirQualityScale, Luftdruck, Feuchtigkeit, date, time FROM sensor_data ORDER BY date DESC, time DESC LIMIT 1";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        $row = $result->fetch_assoc();
    ?>
    <div class="chart-container">
        <p>inside temperature: <span style="font-size: 21pt; color: #FF7F50; font-weight: bold;"> <?php echo $row["Innentemperatur"]; ?> °C</span></p>
        <img src="temperature_graph.php" alt="Temperaturegraph" width="800" height="400">
    </div>
    <div class="chart-container">
        <p>outside temperature: <span style="font-size: 21pt; color: #FF7F50; font-weight: bold;"> <?php echo $row["Aussentemperatur"]; ?> °C</span></p>
        <img src="outtemperature_graph.php" alt="OutTemperaturegraph" width="800" height="400">
    </div>

    <div class="chart-container">
        <p>air pressure: <span style="font-size: 21pt; color: #FF7F50; font-weight: bold;"><?php echo $row["Luftdruck"]; ?> hPa</span></p>
        <img src="airpressure_graph.php" alt="Airpressuregraph" width="800" height="400">
    </div>
    <div class="chart-container">
        <p>inside humidity: <span style="font-size: 21pt; color: #FF7F50; font-weight: bold;"><?php echo $row["Feuchtigkeit"]; ?> %</span></p>
        <img src="humidity_graph.php" alt="Humiditygraph" width="800" height="400">
    </div>

    <div class="chart-container">
        <p>air quality: <span style="font-size: 21pt; color: #FF7F50; font-weight: bold;"> <?php echo $row["AirQuality"]; ?> Index: <?php echo $row["AirQualityScale"]; ?></span></p>
        <img src="airquality_graph.php" alt="AirQualitygraph" width="800" height="400">
    </div>

    <div class="chart-container">
        <p>gas resistance: <span style="font-size: 21pt; color: #FF7F50; font-weight: bold;"> <?php echo $row["Gaswiderstand"]; ?> Index</span></p>
        <img src="gasresistance_graph.php" alt="Gasresistancegraph" width="800" height="400">
    </div>

    <?php
    }
    $conn->close();
    ?>

    <div class="wide-chart-container">
        <p>long term inside temperature</p>
        <img src="long_temperature_graph.php" alt="Temperaturegraph" width="2000" height="400">
    </div>
    <div class="wide-chart-container">
        <p>long term outside temperature</p>
        <img src="long_outtemperature_graph.php" alt="OutTemperaturegraph" width="2000" height="400">
    </div>

    <div class="wide-chart-container">
        <p>long term air pressure</p>
        <img src="long_airpressure_graph.php" alt="Pressuregraph" width="2000" height="400">
    </div>
    <div class="wide-chart-container">
        <p>long term inside humidity</p>
        <img src="long_humidity_graph.php" alt="Humiditygraph" width="2000" height="400">
    </div>
    <div class="wide-chart-container">
        <p>long term air quality</p>
        <img src="long_airquality_graph.php" alt="Airqualitygraph" width="2000" height="400">
    </div>
    <div class="wide-chart-container">
        <p>long term gas resistance</p>
        <img src="long_gasresistance_graph.php" alt="Humiditygraph" width="2000" height="400">
    </div>


</div>

</body>
</html>
