<?php
$servername = "192.168.y.x";
$username = "dbuser";
$password = "password";
$dbname = "sensor_data";

// Verbindung zur Datenbank herstellen
$conn = new mysqli($servername, $username, $password, $dbname);

// Überprüfen, ob die Verbindung erfolgreich war
if ($conn->connect_error) {
    die("Verbindung zur Datenbank fehlgeschlagen: " . $conn->connect_error);
}

// Datum für den aktuellen Tag
$currentDate = date("Y-m-d");

// SQL-Abfrage, um alle relevanten Daten für den aktuellen Tag abzurufen
$sql = "SELECT time, Gaswiderstand FROM sensor_data WHERE date = '$currentDate' ORDER BY time";

$result = $conn->query($sql);

if ($result->num_rows > 0) {
    // Daten sammeln
    while ($row = $result->fetch_assoc()) {
        $data[] = array(
            'time' => date("H:i", strtotime($row['time'])),
            'temperature' => floatval($row['Gaswiderstand'])
        );
    }

    // GD-Bild erstellen
    $width = 900; // Breite des Graphen
    $height = 240; // Höhe des Graphen
    $img = imagecreatetruecolor($width, $height);

    // Hintergrundfarbe festlegen
    $background = imagecolorallocate($img, 255, 255, 255);
    imagefilledrectangle($img, 0, 0, $width, $height, $background);

    // Linienfarben
    $lineColor = imagecolorallocate($img, 255, 0, 0);
    $axisColor = imagecolorallocate($img, 0, 0, 0); // Schwarze Achsen

    // Achsen zeichnen
    imageline($img, 50, 50, 50, $height - 50, $axisColor); // Vertikale Achse
    imageline($img, 50, $height - 50, $width - 50, $height - 50, $axisColor); // Horizontale Achse

    // Basisfrequenz für die Beschriftung (zum Beispiel alle 3 Stunden)
    $baseLabelFrequency = 28;

    // Initialisiere die LabelFrequency mit der Basisfrequenz
    $xLabelFrequency = $baseLabelFrequency;

    // Beschriftung der x-Achse (Zeit)


$dayStart = strtotime($currentDate . ' 00:00:00');
$dayEnd = strtotime($currentDate . ' 23:59:59');
$xLabelFrequency = 2;

for ($timestamp = $dayStart; $timestamp <= $dayEnd; $timestamp += $xLabelFrequency * 3600) {
    $x = 50 + ($timestamp - $dayStart) / (24 * 60 * 60) * ($width - 100); // Anpassung auf 24 Stunden
    imagestring($img, 3, $x, $height - 30, date("H:i", $timestamp), $axisColor);
}
/*

    $numDataPoints = count($data);

    for ($i = 0; $i < $numDataPoints; $i += $xLabelFrequency) {
        $timestamp = strtotime($currentDate . ' ' . $data[$i]['time']);

        // Berechne die Stunde aus dem Zeitstempel
        $hour = date('G', $timestamp);

        // Überprüfe die Uhrzeit und passe die LabelFrequency an
        if ($hour % $baseLabelFrequency === 0) {
            $xLabelFrequency = $baseLabelFrequency;
        } else {
            $xLabelFrequency = $baseLabelFrequency - ($hour % $baseLabelFrequency);
        }

        $x = 50 + ($timestamp - strtotime($currentDate)) / (24 * 60 * 60) * ($width - 100); // Anpassung auf 24 Stunden
        imagestring($img, 3, $x, $height - 30, date("H:i", $timestamp), $axisColor);
    }
*/
    // Beschriftung der y-Achse (Temperatur) für den aktuellen Tag
    $maxTemperature = max(array_column($data, 'temperature'));
    $minTemperature = min(array_column($data, 'temperature'));
    $temperatureRange = $maxTemperature - $minTemperature;
    $yLabelFrequency = $temperatureRange / 10; // 10 Temperaturwerte auf der y-Achse

    for ($i = 0; $i <= 10; $i++) {
        $y = $height - 50 - ($i * ($height - 100) / 10);
        $label = number_format($minTemperature + $i * $yLabelFrequency, 1);
        imagestring($img, 3, 20, $y + 5, $label, $axisColor);
    }

    // Temperaturwerte zeichnen für den aktuellen Tag
    $values = array();
    foreach ($data as $entry) {
        if (isset($entry['time'])) {
            $timestamp = strtotime($currentDate . ' ' . $entry['time']);

            // Umrechnung der Zeit in die x-Position im 24-Stunden-Graphen
            $x = 50 + ($timestamp - strtotime($currentDate)) / (24 * 60 * 60) * ($width - 100);

            // Korrektur, um sicherzustellen, dass x im erwarteten Bereich liegt
            $x = max(50, min($width - 50, $x));

            $y = $height - 50 - (($entry['temperature'] - $minTemperature) / $temperatureRange) * ($height - 100);

            $values[] = $x;
            $values[] = $y;

            // Debug-Ausgabe
            # echo "time: {$entry['time']}, x: $x, y: $y<br>";
        }
    }

    // Zeichnen der Linie (offen) für den aktuellen Tag
    imagesetthickness($img, 2);
    if (count($values) >= 4 && count($values) % 2 === 0) {
        imageopenpolygon($img, $values, count($values) / 2, $lineColor);
    }



    // Vortag-Daten abrufen
    $yesterday = date("Y-m-d", strtotime($currentDate . " -1 day"));
    $sqlYesterday = "SELECT time, Gaswiderstand FROM sensor_data WHERE date = '$yesterday' ORDER BY time";

    $resultYesterday = $conn->query($sqlYesterday);

    if ($resultYesterday->num_rows > 0) {
        // Daten für den Vortag sammeln
        $dataYesterday = array();
        while ($rowYesterday = $resultYesterday->fetch_assoc()) {
            $dataYesterday[] = array(
                'time' => strtotime($yesterday . ' ' . $rowYesterday['time']),
                'temperature' => floatval($rowYesterday['Gaswiderstand'])
            );
        }

        // Beschriftung der y-Achse (Temperatur) für den Vortag
        $maxTemperatureYesterday = max(array_column($dataYesterday, 'temperature'));
        $minTemperatureYesterday = min(array_column($dataYesterday, 'temperature'));
        $temperatureRangeYesterday = $maxTemperatureYesterday - $minTemperatureYesterday;
        $yLabelFrequencyYesterday = $temperatureRangeYesterday / 10; // 10 Temperaturwerte auf der y-Achse

        for ($i = 0; $i <= 10; $i++) {
            $y = $height - 50 - ($i * ($height - 100) / 10);
            $label = number_format($minTemperatureYesterday + $i * $yLabelFrequencyYesterday, 1);
            imagestring($img, 3, $width - 40, $y + 5, $label, $axisColor);
        }

        // Temperaturwerte zeichnen für den Vortag (gestern)
        $valuesYesterday = array();
        for ($i = 0; $i < count($dataYesterday) - 1; $i++) {
            $x1 = 50 + (($dataYesterday[$i]['time'] - $dataYesterday[0]['time']) / (24 * 60 * 60)) * ($width - 100);
            $y1 = $height - 50 - (($dataYesterday[$i]['temperature'] - $minTemperatureYesterday) / $temperatureRangeYesterday) * ($height - 100);

            $x2 = 50 + (($dataYesterday[$i + 1]['time'] - $dataYesterday[0]['time']) / (24 * 60 * 60)) * ($width - 100);
            $y2 = $height - 50 - (($dataYesterday[$i + 1]['temperature'] - $minTemperatureYesterday) / $temperatureRangeYesterday) * ($height - 100);

            if ($x2 <= $width - 50) { // Zeichne nur, wenn x2 im Graphenbereich liegt
                $valuesYesterday[] = $x1;
                $valuesYesterday[] = $y1;
                $valuesYesterday[] = $x2;
                $valuesYesterday[] = $y2;
            }
        }

        // Zeichnen der Linie für den Vortag (gestern)
        $yesterdayColor = imagecolorallocate($img, 173, 216, 230); // Hellblaue Farbe
        imagesetthickness($img, 1);
        imageopenpolygon($img, $valuesYesterday, count($valuesYesterday) / 2, $yesterdayColor);
    }



    // Bild ausgeben
    header("Content-Type: image/png");
    imagepng($img);

    // Bildspeicher freigeben
    imagedestroy($img);
} else {
    echo "Keine Daten für den aktuellen Tag gefunden.";
}

// Verbindung zur Datenbank schließen
$conn->close();
?>
